/*
 *  Boa, an http server
 *  Copyright (C) 1995 Paul Phillips <psp@well.com>
 *  Authorization "module" (c) 1998,99 Martin Hinner <martin@tdp.cz>
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 1, or (at your option)
 *  any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 */

#include <stdio.h>
#include <fcntl.h>
#ifdef EMBED
#include <unistd.h>
#else
#include <crypt.h>
#endif
//#include <inl_misc.h>
#include "boa.h"
#include "bcmnvram.h"


int timeoutflag;
char remoteIPaddr[20];
int  onceloginflag;
int  wanloginflag;
int  remote_off;
char remoteipbuff[20];

#ifdef USE_AUTH

static char auth_userpass[0x80];
//static char admin_passwd[0x80]="";


void auth_read_admin_password()
{
//    struct passwd *pw;
    
//    pw = getpwnam("root");
//    strncpy(admin_passwd, pw->pw_passwd, sizeof(admin_passwd));
}



/*
 * Name: base64decode
 *
 * Description: Decodes BASE-64 encoded string
 */
int base64decode(void *dst,char *src,int maxlen)
{
 int bitval,bits;
 int val;
 int len,x,y;

 len = strlen(src);
 bitval=0;
 bits=0;
 y=0;

 for(x=0;x<len;x++)
  {
   if ((src[x]>='A')&&(src[x]<='Z')) val=src[x]-'A'; else
   if ((src[x]>='a')&&(src[x]<='z')) val=src[x]-'a'+26; else
   if ((src[x]>='0')&&(src[x]<='9')) val=src[x]-'0'+52; else
   if (src[x]=='+') val=62; else
   if (src[x]=='-') val=63; else
    val=-1;
   if (val>=0)
    {
     bitval=bitval<<6;
     bitval+=val;
     bits+=6;
     while (bits>=8)
      {
       if (y<maxlen)
        ((char *)dst)[y++]=(bitval>>(bits-8))&0xFF;
       bits-=8;
       bitval &= (1<<bits)-1;
      }
    }
  }
 if (y<maxlen)
   ((char *)dst)[y++]=0;
 return y;
}



#if 0

static char base64chars[64] = "abcdefghijklmnopqrstuvwxyz"
                              "ABCDEFGHIJKLMNOPQRSTUVWXYZ0123456789./";

/*
 * Name: base64encode()
 *
 * Description: Encodes a buffer using BASE64.
 */
void base64encode(unsigned char *from, char *to, int len)
{
  while (len) {
    unsigned long k;
    int c;

    c = (len < 3) ? len : 3;
    k = 0;
    len -= c;
    while (c--)
      k = (k << 8) | *from++;
    *to++ = base64chars[ (k >> 18) & 0x3f ];
    *to++ = base64chars[ (k >> 12) & 0x3f ];
    *to++ = base64chars[ (k >> 6) & 0x3f ];
    *to++ = base64chars[ k & 0x3f ];
  }
  *to++ = 0;
}


/*
 * Name: auth_check_adminpass
 *
 * Description: if user = admin & pass= the passowrd of root, then return 0
 * , else returns nonzero; As one-way function is used RSA's MD5 w/
 *  BASE64 encoding.
 */
int auth_check_adminpass(char *user,char *pass)
{
	struct MD5Context mc;
 	unsigned char final[16];
	char encoded_passwd[0x40];
  /* Encode password ('pass') using one-way function and then use base64 encoding. */
	MD5Init(&mc);
	MD5Update(&mc, pass, strlen(pass));
	MD5Final(final, &mc);
	strcpy(encoded_passwd,"$1$");
	base64encode(final, encoded_passwd+3, 16);

//    printf("auth_check_userpass(%s,%s,...);\n",user,pass);

	if (!strcmp(user,"admin"))
	{
		if ( ! strcmp(encoded_passwd, admin_passwd) )
			return 0;
	}

	return 1;
}
#endif

int check_subnet_mod(void)
{
	char ip_buf[4][16], *tmptr;
	int subnet_buf[16];
	int i = 0, j = 0;
	
	strcpy(ip_buf[0], nvram_safe_get("last_lan_ipaddr"));
	strcpy(ip_buf[1], nvram_safe_get("last_lan_netmask"));
	strcpy(ip_buf[2], nvram_safe_get("lan_ipaddr"));
	strcpy(ip_buf[3], nvram_safe_get("lan_netmask"));

	nvram_set("last_lan_ipaddr", nvram_safe_get("lan_ipaddr"));
        nvram_set("last_lan_netmask", nvram_safe_get("lan_netmask"));

	for(;i < 4; i ++){
		tmptr = strtok(ip_buf[i], ".");
		while (tmptr) {
			subnet_buf[j] = atoi(tmptr);
			tmptr = strtok (NULL, ".");
			j ++; 
		}
	}
	for(i = 0; i < 4; i ++){
		if((subnet_buf[i] & subnet_buf[i+4]) != (subnet_buf[i+8] & subnet_buf[i+12])){
			return 1;
		}
		   
	}
	return 0;
}
int auth_authorize(request * req)
{
	char *password, *user;
	char admin_passwd[0x80]="";
	static char last_ip[20]="\0";

	/* request timeout */	
	if ( timeoutflag ) {
	  timeoutflag=0;
	  send_r_unauthorizedtimeout(req, auth_realm);
	  onceloginflag=0;
	  last_ip[0]='\0';
	  strcpy(last_ip,req->remote_ip_addr);
	  return 0;
	}
	/* request one user login */
	if( onceloginflag )	{
		if(strcmp(remoteIPaddr,req->remote_ip_addr) != 0 ) {   
			if(check_subnet_mod() != 0) {
				onceloginflag = 0;
				strcpy(last_ip, req->remote_ip_addr);
				strcpy(remoteIPaddr, req->remote_ip_addr);
			}
			else{    
				send_r_unauthorizedlogin(req);
				return 0;
			}
		}
	}

	/* different IP */
	if (last_ip[0]!='\0') {
	    if( strcmp(last_ip,req->remote_ip_addr) != 0 ) {       
	      send_r_unauthorizedtimeout(req, auth_realm);
	      strcpy(last_ip,req->remote_ip_addr);
	      return 0;
	    }
	}
       
	if (! req->authorization) {
	  /* The request contains no authentication, reject it */
	  send_r_unauthorized(req, auth_realm);
	  return 0;
	}
    	else {
	  if (strncasecmp(req->authorization,"Basic ",6)) {
            /* We only accept Basic Authentication */
            send_r_bad_request(req);
            return 0;
	  }
       base64decode(auth_userpass,req->authorization+6,0x100);
#if 0
	user=nvram_safe_get("http_username");
	password=nvram_safe_get("http_passwd");
#endif
	user=nvram_safe_get("ntgr_username");
	password=nvram_safe_get("ngtr_passwd");
	if (user!="") {
	  strncpy(admin_passwd,user,sizeof(admin_passwd));
	}
	strcat(admin_passwd,":");
	if (password!="") {
	  strcat(admin_passwd,password);
	}	
	if ( strcmp(auth_userpass, admin_passwd) !=0 ) {
	  send_r_unauthorized(req, auth_realm);
	  return 0;
	}
	else {
	  strcpy(remoteIPaddr,req->remote_ip_addr);
	  strcpy(last_ip,req->remote_ip_addr);
	  onceloginflag=1;
	  /* request pathname logout.html */
	  if ( !strcmp(req->pathname,"/usr/lib/cgi-bin/logout.html")) {
	    onceloginflag=0;
	  }
	  return 1;
	}
	return 1;
    }
}

#endif
